'use strict';

var TableData = function(){
    var vars = {
            $table : '',
            dashboardType : '',
            dbg: true
        },

        updateUPSVariables = function(v){
            //input section
            vars.$table.find(".vin1").html(v.vin1);
            vars.$table.find(".vin2").html(v.vin2);
            vars.$table.find(".vin3").html(v.vin3);

            vars.$table.find(".ain1").html(fixedValue(v.ain1 / 10, 1));
            vars.$table.find(".ain2").html(fixedValue(v.ain2 / 10, 1));
            vars.$table.find(".ain3").html(fixedValue(v.ain3 / 10, 1));

            vars.$table.find(".fin").html(fixedValue(v.fin / 10, 1));

            //bypass section
            vars.$table.find(".vbyp1").html(v.vbyp1);
            vars.$table.find(".vbyp2").html(v.vbyp2);
            vars.$table.find(".vbyp3").html(v.vbyp3);

            vars.$table.find(".abyp1").html(fixedValue(v.abyp1 / 10, 1));
            vars.$table.find(".abyp2").html(fixedValue(v.abyp2 / 10, 1));
            vars.$table.find(".abyp3").html(fixedValue(v.abyp3 / 10, 1));

            vars.$table.find(".fbyp").html(fixedValue(v.fbyp / 10, 1));

            //output section
            vars.$table.find(".vout1").html(v.vout1);
            vars.$table.find(".vout2").html(v.vout2);
            vars.$table.find(".vout3").html(v.vout3);

            vars.$table.find(".load1").html(v.load1);
            vars.$table.find(".load2").html(v.load2);
            vars.$table.find(".load3").html(v.load3);

            vars.$table.find(".aout1").html(fixedValue(v.aout1 / 10, 1));
            vars.$table.find(".aout2").html(fixedValue(v.aout2 / 10, 1));
            vars.$table.find(".aout3").html(fixedValue(v.aout3 / 10, 1));

            vars.$table.find(".fout").html(fixedValue(v.fout / 10, 1));
            //battery section
            vars.$table.find(".autonomy").html( minToHHMM(v.authonomy) );
            vars.$table.find(".batcap").html( v.batcap );
            vars.$table.find(".vbat").html( fixedValue( v.vbat / 10, 1) );

            vars.$table.find(".tsys").html( v.tsys );
        },

        replaceOutputState = function (o, v) {
            // 0 - output OFF no line
            // 1 - output ON line
            // 2 - shutdown active
            // 3 - shutdown imminent
            // 4 - restore active
            // 5 - overload alarm
            // 6 - lock
            switch (v) {
                case 0:
                    o.html("OFF");
                    break;
                case 1:
                    o.html("ON");
                    break;
                case 2:
                    o.html("Shutdown Active");
                    break;
                case 3:
                    o.html("Shutdown Imminent");
                    break;
                case 4:
                    o.html("Restore Active");
                    break;
                case 5:
                    o.html("Overload");
                    break;
                case 6:
                    o.html("Lock");
                    break;
            }
        },

        updateMDUVariables = function(v){
            //input section
            vars.$table.find(".vin").html(v.vin);
            vars.$table.find(".ain").html(fixedValue(v.ain / 10, 1));
            vars.$table.find(".fin").html(fixedValue(v.fin / 10, 1));

            //output section
            vars.$table.find(".aout1").html(fixedValue(v.aout1 / 10, 1));
            vars.$table.find(".aout2").html(fixedValue(v.aout2 / 10, 1));
            vars.$table.find(".aout3").html(fixedValue(v.aout3 / 10, 1));
            vars.$table.find(".aout4").html(fixedValue(v.aout4 / 10, 1));
            vars.$table.find(".aout5").html(fixedValue(v.aout5 / 10, 1));
            vars.$table.find(".aout6").html(fixedValue(v.aout6 / 10, 1));
            vars.$table.find(".aout7").html(fixedValue(v.aout7 / 10, 1));
            vars.$table.find(".aout8").html(fixedValue(v.aout8 / 10, 1));
            replaceOutputState(vars.$table.find(".sout1"), v.sout1);
            replaceOutputState(vars.$table.find(".sout2"), v.sout2);
            replaceOutputState(vars.$table.find(".sout3"), v.sout3);
            replaceOutputState(vars.$table.find(".sout4"), v.sout4);
            replaceOutputState(vars.$table.find(".sout5"), v.sout5);
            replaceOutputState(vars.$table.find(".sout6"), v.sout6);
            replaceOutputState(vars.$table.find(".sout7"), v.sout7);
            replaceOutputState(vars.$table.find(".sout8"), v.sout8);

            vars.$table.find(".tsys").html( v.tsys );
        },

        updateSTSVariables = function(v){
            //input section
            vars.$table.find(".vin1s1").html(v.vin1s1);
            vars.$table.find(".vin2s1").html(v.vin2s1);
            vars.$table.find(".vin3s1").html(v.vin3s1);

            vars.$table.find(".vin1s2").html(v.vin1s2);
            vars.$table.find(".vin2s2").html(v.vin2s2);
            vars.$table.find(".vin3s2").html(v.vin3s2);

            vars.$table.find(".fins1").html(fixedValue(v.fins1 / 10, 1));
            vars.$table.find(".fins2").html(fixedValue(v.fins2 / 10, 1));


            //output section
            vars.$table.find(".load1").html(v.load1);
            vars.$table.find(".load2").html(v.load2);
            vars.$table.find(".load3").html(v.load3);

            vars.$table.find(".aout1").html(fixedValue(v.aout1 / 10, 1));
            vars.$table.find(".aout2").html(fixedValue(v.aout2 / 10, 1));
            vars.$table.find(".aout3").html(fixedValue(v.aout3 / 10, 1));

            vars.$table.find(".phasediff").html( v.phasediff );
            vars.$table.find(".tsys").html( v.tsys );
        },

        updateIRMSVariables = function(v){
            //input section
            vars.$table.find(".vin1s1").html(v.vin1s1);
            vars.$table.find(".fins1").html(fixedValue(v.fins1 / 10, 1));
            vars.$table.find(".statuss1").html(v.statuss1);
            vars.$table.find(".s1hole").html(v.s1hole);

            //input section
            vars.$table.find(".vin1s2").html(v.vin1s2);
            vars.$table.find(".fins2").html(fixedValue(v.fins2 / 10, 1));
            vars.$table.find(".statuss2").html(v.statuss2);
            vars.$table.find(".s2hole").html(v.s2hole);

            //output section
            vars.$table.find(".aout1").html(fixedValue(v.aout1 / 10, 1));
            vars.$table.find(".aout2").html(fixedValue(v.aout2 / 10, 1));
            vars.$table.find(".aout3").html(fixedValue(v.aout3 / 10, 1));
            vars.$table.find(".aout4").html(fixedValue(v.aout4 / 10, 1));
            vars.$table.find(".aout5").html(fixedValue(v.aout5 / 10, 1));
            vars.$table.find(".aout6").html(fixedValue(v.aout6 / 10, 1));
            vars.$table.find(".aout7").html(fixedValue(v.aout7 / 10, 1));
            vars.$table.find(".aout8").html(fixedValue(v.aout8 / 10, 1));
            vars.$table.find(".load1").html(v.load1);
            vars.$table.find(".load2").html(v.load2);
            vars.$table.find(".load3").html(v.load3);
            vars.$table.find(".load4").html(v.load4);
            vars.$table.find(".load5").html(v.load5);
            vars.$table.find(".load6").html(v.load6);
            vars.$table.find(".load7").html(v.load7);
            vars.$table.find(".load8").html(v.load8);
            replaceOutputState(vars.$table.find(".sout1"), v.sout1);
            replaceOutputState(vars.$table.find(".sout2"), v.sout2);
            replaceOutputState(vars.$table.find(".sout3"), v.sout3);
            replaceOutputState(vars.$table.find(".sout4"), v.sout4);
            replaceOutputState(vars.$table.find(".sout5"), v.sout5);
            replaceOutputState(vars.$table.find(".sout6"), v.sout6);
            replaceOutputState(vars.$table.find(".sout7"), v.sout7);
            replaceOutputState(vars.$table.find(".sout8"), v.sout8);
            vars.$table.find(".sourceout1").html(v.sourceout1 ? 'B' : 'A');
            vars.$table.find(".sourceout2").html(v.sourceout2 ? 'B' : 'A');
            vars.$table.find(".sourceout3").html(v.sourceout3 ? 'B' : 'A');
            vars.$table.find(".sourceout4").html(v.sourceout4 ? 'B' : 'A');
            vars.$table.find(".sourceout5").html(v.sourceout5 ? 'B' : 'A');
            vars.$table.find(".sourceout6").html(v.sourceout6 ? 'B' : 'A');
            vars.$table.find(".sourceout7").html(v.sourceout7 ? 'B' : 'A');
            vars.$table.find(".sourceout8").html(v.sourceout8 ? 'B' : 'A');

            vars.$table.find(".phasediff").html( v.phasediff );
        },

    // ----- Init -----
        init = function init() {
            if ( !($("#table-UPS").hasClass("hidden"))) {
                vars.$table = $("#table-UPS");
            }
            else if ( !($("#table-MDU").hasClass("hidden"))) {
                vars.$table = $("#table-MDU");
            }
            else if (!$("#table-STS").hasClass("hidden")) {
                vars.$table = $("#table-STS");
            }
            else if (!$("#table-IRMS").hasClass("hidden")) {
                vars.$table = $("#table-IRMS");
            }

        };

    return {
        init: function(){ init(); },
        updateUPSVariables: updateUPSVariables,
        updateMDUVariables: updateMDUVariables,
        updateSTSVariables: updateSTSVariables,
        updateIRMSVariables: updateIRMSVariables,
    }
}();
